/*
 * This file contains all code sepecific to the wlan-ng Interface
 *
 *
 * RevHist
 *
 * When         Who             What
 * 02-05-30     jafern          Created version for wlan-ng 0.14 with libpcap support,
 *				Removed support for old system(3) call of wlan_ng
 *
 * 02-03-26	jafer		Code moved out of prismstumbler.c
 * 
 *
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <unistd.h>
#include <time.h>
#include <string.h>
#include "libpcap-0.7.1/pcap.h"
#include "wlanctl/wlanctl.h"
#include "psgui.h"

#ifndef DLT_PRISM_HEADER
	#define DLT_PRISM_HEADER 119
#endif


typedef struct CaptureArg_t {
   pcap_t *pcap;
   pcap_dumper_t *dump;
   int offset;
} CaptureArg;

static void  openCard(void);
static CaptureArg ca;
static char errbuf[PCAP_ERRBUF_SIZE];

extern int g_offset;
char logbuf[120];


/*
 * Open the Capture device 
 */
int openPacket(void){
	
	openCard();
	ca.pcap = pcap_open_live("wlan0", 3000, 1, 0, errbuf);
	if (ca.pcap) {

		pcap_setnonblock(ca.pcap,1,errbuf);

		switch (pcap_datalink(ca.pcap)) {
			 case DLT_PRISM_HEADER:
				sprintf(logbuf,"pcap: DLT_PRISM_HEADER\n");
				ca.offset = 144;//sizeof(AdmInfo_t);//144;
				break;
			case DLT_IEEE802_11:
				sprintf(logbuf,"pcap: DLT_IEEE802_11\n");
				ca.offset = 0;
				break;
			case DLT_AIRONET_HEADER:
				sprintf(logbuf,"pcap: DLT_AIRONET_HEADER\n");
				ca.offset = 0;
				break;
			default: //COOKED
				sprintf(logbuf,"pcap: COOKED\n");
				ca.offset = 160;
		}
 		printlog(logbuf);
		g_offset = ca.offset;
		return 1;
	}
	return -1;
		

}

	
int getPacket(unsigned char *buf,int maxlen,int timeout) {
        struct pcap_pkthdr pktHdr;
	u_char *ret;
   	fd_set rs;
        int r;
        struct timeval tm;
        struct timeval *ptm;


/* Stress  down system and make a select with no  fd */
        FD_ZERO(&rs);
        if (timeout>=0) {
                tm.tv_sec=timeout/1000;
                tm.tv_usec=(timeout%1000)*1000;
                ptm=&tm;
        } else {
                ptm=NULL;
        }
        r=select(0,&rs,NULL,NULL,ptm);


	ret = (u_char *)pcap_next(ca.pcap,&pktHdr);

	if( ret ){
		memcpy(buf,ret,pktHdr.len);
		return pktHdr.len;
	}else{
		return 0;
	}
}


/*
 * Just a wrapper....
 */
void closePacket(int RawSock){
	pcap_close(ca.pcap);
}


void shutCard(void){
        char *argv[10];
        int argc;
	memset(argv,0,10);
	system("ifconfig wlan0 down");
        argv[0] = "wlanctl";
        argv[1] = "wlan0";
        argv[2] = "lnxreq_wlansniff";
        argv[3] = "enable=false";
	argv[4] = NULL;
        argc=4;
        wlanctl(argc,argv);
	memset(argv,0,10);
        argv[0] = "wlanctl";
        argv[1] = "wlan0";
        argv[2] = "lnxreq_ifstate";
        argv[3] = "ifstate=disable";
	argv[4] = NULL;
       wlanctl(argc,argv);
}


int selectChannel(int channel){
        char Channel[255];
        char *argv[10];
 		int argc;

		memset(argv,0,10);
        sprintf(Channel,"channel=%d",channel);

        argv[0] = "wlanctl";
        argv[1] = "wlan0";
        argv[2] = "lnxreq_wlansniff";
        argv[3] = "enable=false";
        argv[4] = NULL;
        argc=4;
		wlanctl(argc,argv);

		memset(argv,0,10);
  		argv[0] = "wlanctl";
        argv[1] = "wlan0";
        argv[2] = "lnxreq_wlansniff";
        argv[3] = Channel;
        argv[4] = "enable=true";
		argv[5] = "prismheader=true";
		argv[6] = "keepwepflags=false";
//		argv[7] = "stripfcs=false";
        argv[7] = NULL;
        argc=7;
		wlanctl(argc,argv);
	return 0;
}

static void  openCard(void){
        char *argv[10];
        int argc;
	memset(argv,0,10);

        argv[0] = "wlanctl";
        argv[1] = "wlan0";
        argv[2] = "lnxreq_ifstate";
        argv[3] = "ifstate=enable";
		argv[4] = NULL;
        argc=4;
        wlanctl(argc,argv);
	system("ifconfig wlan0 up");
}




