/*
 * Anfngliche Datei main.c, erzeugt durch Glade. Bearbeiten Sie
 * Sie, wie Sie wollen. Glade wird diese Datei nicht berschreiben.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>
#include <pthread.h>
#include "prismstumbler.h"
#include "ps_resolv.h"
#include "interface.h"
#include "support.h"

extern char * OutFileName;
extern FILE * OutFile;
extern char * WPFileName;
extern FILE * WPFile;


int
main (int argc, char *argv[])
{
	GtkWidget *fMain;
	int psthread_id;
	pthread_t psthread;

	int c;
	int enable_scan = TRUE;

    char* mygtkrc;
	char* tmpenv;
	while(  ( c = getopt(argc,argv,"dS:F:w:") ) != EOF ){
		switch(c){
			case 'S':{
						SingleChannel = atoi(optarg);
						if( SingleChannel < 1 || SingleChannel > 14 ){
							HelpAndBye();
						}
						break;
					}
					
			case 'F':   	OutFileName = optarg;
					break;
			case 'w':   	WPFileName = optarg;
					break;
			case 'd': 	enable_scan=FALSE;
					break;
			case '?':       HelpAndBye();
					break;
		}
	}

	if( OutFileName ){
		if(( OutFile = fopen(OutFileName,"w")) == NULL ){
			fprintf(stderr,"Cant open outfile %s for writing\n",OutFileName);
			exit(1);
		}
	}

	if( WPFileName ){
		if(( WPFile = fopen(WPFileName,"w")) == NULL ){
			fprintf(stderr,"Cant open waypoint file %s for writing\n",WPFileName);
			exit(1);
		}
	}

	gtk_init (&argc,&argv);

	tmpenv = getenv("HOME");
	mygtkrc = malloc(strlen(tmpenv)+1);
	mygtkrc = strcpy(mygtkrc,tmpenv);
	mygtkrc = realloc(mygtkrc,strlen(mygtkrc)+20);
	mygtkrc = strcat(mygtkrc,"/.pstumbler/gtkrc");

	gtk_rc_parse (mygtkrc);
	free(mygtkrc);	

	if (enable_scan) {
		psthread_id = pthread_create(&psthread,(pthread_attr_t*)NULL,(void*)psmain,(void*)SingleChannel);
		fprintf (stderr, "Use CTRL-C to stop sniffing or press q.\n");
	}
	else
		fprintf (stderr, "Sniffer disabled - running db-only.\n");


  /*
   * The following code was added by Glade to create one of each component
   * (except popup menus), just so that you see something after building
   * the project. Delete any components that you don't want shown initially.
   */
	fMain = create_fMain ();
	gtk_widget_show (fMain);

	gtk_main ();
		
	return 0;
}

