#ifndef _PRISMSTUMBLER_H
#define _PRISMSTUMBLER_H
/***************************************************************************
                          prismstumbler.h  -  description
                             -------------------
    begin                : Wed Aug 14 2002
    copyright            : (C) 2002 by Jan Fernquist, Florian Boor
    email                : boor@unix-ag.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <unistd.h>
#include <time.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <sys/resource.h>
#include <pthread.h>

#define VERSIONSTR "prismstumbler 0.6.0"

#define MAX_BUFFER_SIZE 4000	/* Size of receive buffer */
#define __WLAN_ATTRIB_PACK__       __attribute__ ((packed))
#define MCAST_GRP_SNIFF 0x00000002	/* Value used to notify netlink  */

#define FAKEAP_LEVEL 7

typedef struct {
	char DestMac[20];
	char SrcMac[20];
	char BssId[20];
	char SSID[80];
	int hasWep;
	int isAp;
	int  Channel;
	int Signal;
    int Noise;
    int FrameType;
	float longitude, latitude;
	int isData;
	int hasIntIV;
	int dhcp;
	unsigned char subnet[5];
}ScanResult_t;


typedef struct {
	int isvalid;
	char ssid[80];
	char bssid[32];
	time_t first, last;
	char type[20];
	unsigned char ip_range[5];
	int wep;
	int dhcp;
	char ap[16];
	unsigned long pdata,psum,pint;
	char wep_key[48];
	float longitude, latitude;
	int maxsiglevel;
	int cursiglevel;	
	int channel;
	int ishidden;
} psnetinfo_t;


void HelpAndBye(void);
void psmain (int fixchannel);
extern void update_colors();
extern void update_all(ScanResult_t aresult, time_t t_when);
extern int SingleChannel;
extern pthread_mutex_t buf_mutex;

extern int newnet_count;

#endif

